package org.metaabm.gen.test;

import org.metaabm.gen.test.share.AgentTestCase;

/**
 * Spatial Model Java Implementation. Generated by metaabm system: Apr 13, 2008
 * 3:03:56 PM EDT in project: org.metaabm.gen.repast.test (testing)
 */
public class SpatialModelTestCase extends AgentTestCase {

    /**
     * Constructs a new Spatial Model.
     */
    public SpatialModelTestCase() {
        super("org.eclipse.amp.amf.gen.repast.test.target", "Spatial Model Test", "org.eclipse.amp.amf.gen.test.SpatialModel");
    }

    public void setUp() {
        agentLoaded = new SpatialModel();
    }

    public ISpatialModel getAgent() {
        return (ISpatialModel) agentLoaded;
    }

    public void testExistence() {
        assertNotNull(getAgent());
    }

    /**
     * Gets the Complex Movement Agent Count property for Spatial Model.
     * 
     * @return The number of complex movement agents to create.
     */
    public int getComplexMovementAgentCount() {
        return getAgent().getComplexMovementAgentCount();
    }

    /**
     * Sets the Complex Movement Agent Count property for Spatial Model. The
     * number of complex movement agents to create.
     * 
     * @param _complexMovementAgentCount the new Complex Movement Agent Count
     *            value
     */
    public void setComplexMovementAgentCount(int complexMovementAgentCount) {
        getAgent().setComplexMovementAgentCount(complexMovementAgentCount);
    }

    /**
     * Gets the Complex Location Count property for Spatial Model.
     * 
     * @return The number of complex locations to create.
     */
    public int getComplexLocationCount() {
        return getAgent().getComplexLocationCount();
    }

    /**
     * Sets the Complex Location Count property for Spatial Model. The number of
     * complex locations to create.
     * 
     * @param _complexLocationCount the new Complex Location Count value
     */
    public void setComplexLocationCount(int complexLocationCount) {
        getAgent().setComplexLocationCount(complexLocationCount);
    }

    /**
     * Gets the Spatial Model Agent Count property for Spatial Model.
     * 
     * @return The number of spatial model agents to create.
     */
    public int getSpatialModelAgentCount() {
        return getAgent().getSpatialModelAgentCount();
    }

    /**
     * Sets the Spatial Model Agent Count property for Spatial Model. The number
     * of spatial model agents to create.
     * 
     * @param _spatialModelAgentCount the new Spatial Model Agent Count value
     */
    public void setSpatialModelAgentCount(int spatialModelAgentCount) {
        getAgent().setSpatialModelAgentCount(spatialModelAgentCount);
    }

    /**
     * Gets the Good Boundary property for Spatial Model.
     * 
     * @return
     */
    public double[] getGoodBoundary() {
        return getAgent().getGoodBoundary();
    }

    /**
     * Sets the Good Boundary property for Spatial Model.
     * 
     * @param _goodBoundary the new Good Boundary value
     */
    public void setGoodBoundary(double[] goodBoundary) {
        getAgent().setGoodBoundary(goodBoundary);
    }
}
