/**
 * <copyright>
 *
 * Copyright (c) 2009 Metascape, LLC.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Metascape - Initial API and Implementation
 *
 * </copyright>
 *
*/
package org.metaabm.gen.test;

/**
 * Basic Movement Model Java Implementation.
 * Most recent version.
 * Generated by metaabm system: May 12, 2009 7:32:32 PM PDT in project: org.metaabm.gen.test  (testing) */

import static org.junit.Assert.*;

public class BasicMovementModel {

	/**
	 * The number of areas to create.
	 */

	private int areaCount = 0;
	/**
	 * The number of network agents to create.
	 */

	private int networkAgentCount = 0;
	/**
	 * The number of generate act people to create.
	 */

	private int basicMovementAgentCount = 0;
	/**
	 * The number of complex space agents to create.
	 */

	private int complexSpaceAgentCount = 0;
	/**
	 * The number of act non movement persons to create.
	 */

	private int actNonMovementPersonCount = 0;
	/**
	 * The number of basic movement state agents to create.
	 */

	private int basicMovementStateAgentCount = 0;
	/**
	 * The size of each dimension.
	 */

	private int[] gridDimensions = new int[2];
	/**
	 * 
	 */

	private Object grid = null;
	/**
	 * 
	 */

	private Object testNetwork = null;
	/**
	 * Constructs a new Basic Movement Model.
	 */

	public BasicMovementModel() {
		createUniqueID();
		setGridWidth(100);
		setGridHeight(50);
	}
	//todo, make this a useful value for evaluating compatibility of different versions of generated classes
	private static final long serialVersionUID = 89989998L;

	private String uniqueID;

	public String getUID() {
		return uniqueID;
	}

	public void createUniqueID() {
		uniqueID = org.apache.commons.lang.RandomStringUtils
				.randomAlphanumeric(5);
	}

	/**
	 * Clones the agent, ensuring that a unique id is assigned.
	 */
	public Object clone() {
		try {
			BasicMovementModel clone = (BasicMovementModel) super.clone();
			clone.createUniqueID();
			return clone;
		} catch (Exception e) {
			throw new RuntimeException("Unexpected cloning exception: " + e);
		}
	}

	@org.junit.Test
	public void dummy() {
		assertTrue(true);
	}

	/**
	 * .
	 */

	@org.junit.Test
	public void testFake() {

		/*PROTECTED REGION ID(BasicMovementModel_testFake_Pre) ENABLED START*/
		//Pre-Conditions Here
		/*PROTECTED REGION END*/

		assertTrue(true);

		/*PROTECTED REGION ID(BasicMovementModel_testFake_Post) ENABLED START*/
		//Post-Conditions Here
		/*PROTECTED REGION END*/

	}
	/**
	 * Gets the Area Count property for Basic Movement Model.
	 * @return The number of areas to create.
	 */

	public int getAreaCount() {
		return areaCount;
	}

	/**
	 * Sets the Area Count property for Basic Movement Model.
	 * The number of areas to create.
	 * @param _areaCount the new Area Count value
	 */

	public void setAreaCount(int _areaCount) {
		areaCount = _areaCount;
	}
	/**
	 * Gets the Network Agent Count property for Basic Movement Model.
	 * @return The number of network agents to create.
	 */

	public int getNetworkAgentCount() {
		return networkAgentCount;
	}

	/**
	 * Sets the Network Agent Count property for Basic Movement Model.
	 * The number of network agents to create.
	 * @param _networkAgentCount the new Network Agent Count value
	 */

	public void setNetworkAgentCount(int _networkAgentCount) {
		networkAgentCount = _networkAgentCount;
	}
	/**
	 * Gets the Basic Movement Agent Count property for Basic Movement Model.
	 * @return The number of generate act people to create.
	 */

	public int getBasicMovementAgentCount() {
		return basicMovementAgentCount;
	}

	/**
	 * Sets the Basic Movement Agent Count property for Basic Movement Model.
	 * The number of generate act people to create.
	 * @param _basicMovementAgentCount the new Basic Movement Agent Count value
	 */

	public void setBasicMovementAgentCount(int _basicMovementAgentCount) {
		basicMovementAgentCount = _basicMovementAgentCount;
	}
	/**
	 * Gets the Complex Space Agent Count property for Basic Movement Model.
	 * @return The number of complex space agents to create.
	 */

	public int getComplexSpaceAgentCount() {
		return complexSpaceAgentCount;
	}

	/**
	 * Sets the Complex Space Agent Count property for Basic Movement Model.
	 * The number of complex space agents to create.
	 * @param _complexSpaceAgentCount the new Complex Space Agent Count value
	 */

	public void setComplexSpaceAgentCount(int _complexSpaceAgentCount) {
		complexSpaceAgentCount = _complexSpaceAgentCount;
	}
	/**
	 * Gets the Act Non Movement Person Count property for Basic Movement Model.
	 * @return The number of act non movement persons to create.
	 */

	public int getActNonMovementPersonCount() {
		return actNonMovementPersonCount;
	}

	/**
	 * Sets the Act Non Movement Person Count property for Basic Movement Model.
	 * The number of act non movement persons to create.
	 * @param _actNonMovementPersonCount the new Act Non Movement Person Count value
	 */

	public void setActNonMovementPersonCount(int _actNonMovementPersonCount) {
		actNonMovementPersonCount = _actNonMovementPersonCount;
	}
	/**
	 * Gets the Basic Movement State Agent Count property for Basic Movement Model.
	 * @return The number of basic movement state agents to create.
	 */

	public int getBasicMovementStateAgentCount() {
		return basicMovementStateAgentCount;
	}

	/**
	 * Sets the Basic Movement State Agent Count property for Basic Movement Model.
	 * The number of basic movement state agents to create.
	 * @param _basicMovementStateAgentCount the new Basic Movement State Agent Count value
	 */

	public void setBasicMovementStateAgentCount(
			int _basicMovementStateAgentCount) {
		basicMovementStateAgentCount = _basicMovementStateAgentCount;
	}
	/**
	 * Gets the Dimensions property for Grid.
	 * @return The size of each dimension.
	 */

	public int[] getGridDimensions() {
		return gridDimensions;
	}

	/**
	 * Sets the Dimensions property for Grid.
	 * The size of each dimension.
	 * @param _gridDimensions the new Dimensions value
	 */

	public void setGridDimensions(int[] _gridDimensions) {
		gridDimensions = _gridDimensions;
	}
	/**
	 * Gets the Width property for Grid.
	 * @return The horizontal extent of the space.
	 */

	public int getGridWidth() {
		return gridDimensions[0];
	}

	/**
	 * Sets the Width property for Grid.
	 * The horizontal extent of the space.
	 * @param _gridWidth the new Width value
	 */

	public void setGridWidth(int _gridWidth) {
		gridDimensions[0] = _gridWidth;
	}
	/**
	 * Gets the Height property for Grid.
	 * @return The vertical extent of the space.
	 */

	public int getGridHeight() {
		return gridDimensions[1];
	}

	/**
	 * Sets the Height property for Grid.
	 * The vertical extent of the space.
	 * @param _gridHeight the new Height value
	 */

	public void setGridHeight(int _gridHeight) {
		gridDimensions[1] = _gridHeight;
	}
	/**
	 * Gets the Grid property for Basic Movement Model.
	 * @return 
	 */

	public Object getGrid() {
		return grid;
	}

	/**
	 * Sets the Grid property for Basic Movement Model.
	 * 
	 * @param _grid the new Grid value
	 */

	public void setGrid(Object _grid) {
		grid = _grid;
	}
	/**
	 * Gets the Test Network property for Basic Movement Model.
	 * @return 
	 */

	public Object getTestNetwork() {
		return testNetwork;
	}

	/**
	 * Sets the Test Network property for Basic Movement Model.
	 * 
	 * @param _testNetwork the new Test Network value
	 */

	public void setTestNetwork(Object _testNetwork) {
		testNetwork = _testNetwork;
	}
}
